function Dashboard2(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = this._gtdinboxPage._labels;
	this._eventObservers = new GtdEventObservers(this);
		
	this._searcherNumberResults = new Searcher(this._gtdinboxPage);
}

Dashboard2.prototype.create = function(){

try{
	/*
	if( !this.elReviews ){
		this.elReviews = this._doc.createElement("SELECT");
			this.elReviews.className = "dashboard-combo-reviews dashboard-combo";
		var elMoreActions = this._gtdinboxPage.gmailDOM.element("action-combo");
		elMoreActions.parentNode.insertBefore( this.elReviews, elMoreActions.nextSibling );
		
		this._eventObservers.observe( this.elReviews, "click", this._clickLink, false );
	}
	*/
	
	if( !this.elTasks ){
		this.elTasks = this._doc.createElement("SELECT");
			this.elTasks.className = "dashboard-combo-tasks dashboard-combo";
			this.elTasks.setAttribute("title", this._gtdinboxPage.stringBundle.getString("Dashboard.Tooltip"));
		var elMoreActions = this._gtdinboxPage.gmailDOM.element("action-combo");
		elMoreActions.parentNode.insertBefore( this.elTasks, elMoreActions.nextSibling );
		
		this._eventObservers.observe( this.elTasks, "click", this._clickLink, false );
	}
	
	this.refresh();
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard2 create\n" + e.toString());
}
	
};

Dashboard2.prototype.viewChange = function(gmail){
	// Update this.elTasks and this.elReviews
	// If not found, create them for this view
	
	if( this._gtdinboxPage.view("view")!="tl" && this._gtdinboxPage.view("view")!="cv" ){
		return;
	}
	
	this.elTasks = this._gtdinboxPage.gmailDOM.element("tasks-combo");
	//this.elReviews = this._gtdinboxPage.gmailDOM.element("reviews-combo");
	
	
	if( !this.elTasks  ){ // || !this.elReviews
		this.create();
	}
	
	this.elTasks.selectedIndex = 0;
	//this.elReviews.selectedIndex = 0;
};

Dashboard2.prototype.refreshNumberResults = function(){
try{
	var gtdinboxPage = this._gtdinboxPage;
	var els = {};
	for( var i = 0; i < this.elTasks.childNodes.length; i++ ){
		var el = this.elTasks.childNodes[i];
		if( el.getAttribute("show-number-results")=="1" ){
			el.innerHTML = el.innerHTML.replace(/\s*\([^)]+?\)$/, "");
			var s = el.getAttribute("gtdSearch");
			s = this.parseSearchString(s);
			els[s] = el;
			var callback = function(query, count){
					if( count > 20 ) count = ">20"; 
					if( els[query] ) els[query].innerHTML = els[query].innerHTML.replace(/\s*\([^)]+?\)$/, "") + " (" + count + ")";
					GIPROTOTYPE.removeClassName(els[query], "many-results");
					if( count > 0 ) GIPROTOTYPE.addClassName(els[query], "many-results");
				};
			this._searcherNumberResults.getNumberResults(s, callback);
		}		
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard2 refreshNumberResults\n" + e.toString());
}
};

Dashboard2.prototype.refresh = function(){

try{
	
	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;
	var statusDefaults = this._gtdinboxPage.settings.labels.types.Statuses.defaults;

	// Rebuild the lists
	this.elTasks.innerHTML = "";
	//this.elReviews.innerHTML = "";
	
	this._addTitle( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard") );
	this._addTitle( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks"), true);
	this.elTasks.selectedIndex = 0;
	//this.elReviews.selectedIndex = 0;
	
	// Tasks
	
	var statusLabels = this._labels.getLabelsArray("Statuses");
	var statusStr = "";
	var statusFinished = this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished;
	for( var i = 0; i < statusLabels.length; i++ ) if(statusLabels[i]!=statusFinished) statusStr += ((i>0)? " OR ":"") + GIPROTOTYPE.searchableLabel(statusLabels[i]);
	statusStr += " -" + GIPROTOTYPE.searchableLabel(statusFinished);
	this._addItem( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks.ShowAllTasks"), null, statusStr, null, true );
	
	var labels = GIPROTOTYPE.clone(this._labels.getLabelsArray("Statuses"));	
	var settingsStatus = this._gtdinboxPage.settings.labels.types.Statuses;
	var labelSearch = "";
	for( d in settingsStatus.defaults ){ // Process defaults
		var label = settingsStatus.prefix + settingsStatus.defaults[d];
		for( var i = 0; i < labels.length; i++ ){
			if( labels[i]==label ){
				if( d=="Action" ){
					labelSearch = "(" + GIPROTOTYPE.searchableLabel(label) + " OR " + GIPROTOTYPE.searchableLabel(settingsStatus.prefix + settingsStatus.defaults.NextAction) + ")";
				}else{
					labelSearch = GIPROTOTYPE.searchableLabel(label);
				}
				if( d!="Finished" ) labelSearch += " -" + GIPROTOTYPE.searchableLabel(statusFinished);
				var title = this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks." + d) || label.replace(settingsStatus.prefix, "");
				this._addItem( this.elTasks, title, label, labelSearch, null, true );
				labels.splice(i,1);
				i--;
			}
		}
	}
	for( var i = 0; i < labels.length; i++ ){	// And the rest
		var label = labels[i];
		this._addItem( this.elTasks, label.replace(settingsStatus.prefix,""), label, GIPROTOTYPE.searchableLabel(label) + " -" + GIPROTOTYPE.searchableLabel(statusFinished), null, true);
	}
	this._addItem( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks.Personal"), null, "<gtdinbox.personalemail> " + GIPROTOTYPE.searchableLabel(statusPrefix + statusDefaults.Action) + " -" + GIPROTOTYPE.searchableLabel(statusFinished), null, true);


	// Reviews
	var knownIds = {};
	
	this._addTitle( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews"), true);
	var reviews = this._gtdinboxPage.settings.reviews;
	if( reviews ){
		var categories = {};
		
		for( var i = 0; i < reviews.length; i++ ){
			var title = reviews[i].title;
			if( !title && reviews[i].titleKey ) title = this._gtdinboxPage.stringBundle.getString(reviews[i].titleKey);
			
			var category = reviews[i].category;
			if( !category && reviews[i].categoryKey ) category = this._gtdinboxPage.stringBundle.getString(reviews[i].categoryKey);
			if( !category ) category = this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.Misc");
			
			var search = reviews[i].search;
			// Look for variables
			var variables = search.match(/<\?\=([^>]+?)>/g);
			if( variables ){
				for( var j = 0; j < variables.length; j++ ){
					var variableData = variables[j].match(/<\?\=([^>]+?)>/);
					if( variableData.length > 1 ){
						var args = variableData[1].split(".");
						var substitute = "";
						switch(args[0]){
							case "DaysAgo":
								substitute = GIPROTOTYPE.searchDate( (new Date()).valueOf() - (1000*60*60*24*parseInt(args[1])) );
								break;
							case "MonthsAgo":
								substitute = GIPROTOTYPE.searchDate( (new Date()).valueOf() - ((1000*60*60*24*31)*parseInt(args[1])) );
								break;
							case "DefaultStatus":
								substitute = GIPROTOTYPE.searchableLabel(statusPrefix + statusDefaults[args[1]]);
								break;
						}
						search = search.replace(variables[j], substitute);
					}
				}
			}
			
			if( title && !knownIds[reviews[i].id] ){
				if( !categories[category] )	categories[category] = this._addTitle(this.elTasks, category);
				categories[category] = this._addItem(this.elTasks, title, null, search, categories[category].nextSibling);
				knownIds[reviews[i].id] = true;
			}
		}		
	}
	
	// Add Recent Projects:
	var projects = this._gtdinboxPage.sp.getRecentlyAttachedProjects();
	if( projects.length > 0 ){
		this._addTitle( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.RecentProjects") );
		for( var i = 0; (i < projects.length) && (i < 4); i++ ){
			this._addItem( this.elTasks, projects[i], projects[i] );
		}
	}
	
	// Add Modify
	this._addTitle( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.Options"), true );
	var elModify = this._addItem( this.elTasks, this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.ModifyReviews") );
	elModify.title = this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.ModifyReviews.Tooltip");
	elModify.style.fontStyle = "italic";
	elModify.setAttribute("gtd.act", "modifyreviews");
	
	
	this.refreshNumberResults();
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard2 create\n" + e.toString());
}

};

Dashboard2.prototype._addTitle = function(elCombo, title, superTitle){
	var el = this._doc.createElement("OPTION");
		el.className = "title";
	el.innerHTML = title;
	
	if( superTitle ) el.className += " super-title";
	
	elCombo.appendChild( el );
	return el;
};

Dashboard2.prototype._addItem = function(elCombo, title, labelName, search, insertBefore, showNumberResults){
	var el = this._doc.createElement("OPTION");
		el.className = "line-item";
		if( !labelName ) labelName = "";
		el.setAttribute("gtdLabelName", labelName);
		if( !search ) search = labelName;
		el.setAttribute("gtdSearch", search);
	el.innerHTML = title;
	if( showNumberResults ) el.setAttribute("show-number-results", "1");
	
	if( insertBefore ){
		elCombo.insertBefore( el, insertBefore );
	}else{
		elCombo.appendChild( el );
	}
	
	return el;
};


Dashboard2.prototype._clickLink = function(event){
try{
	if( event.button!=0 ) return;
	
	
	var el = GIPROTOTYPE.element(event);
	
	if( el.nodeName=="SELECT" ){
		this.refreshNumberResults();
	}
	
	// Set Combo index back:
	var elCombo = el.parentNode;
	while( elCombo.parentNode && elCombo.nodeName!="SELECT" ){
		elCombo = elCombo.parentNode;
	}
	if( elCombo.nodeName=="SELECT" ) elCombo.selectedIndex = 0;
	
	if( el.getAttribute("gtd.act")=="modifyreviews" ){
		this._gtdinboxPage._lightbox.setType( "modifyreviews" );
		this._gtdinboxPage._lightbox.active(true);
		return;
	}
	
	var searchStr = el.getAttribute("gtdSearch");
	if( !searchStr ){
		var label = {name:el.getAttribute("gtdName"), labelname:el.getAttribute("gtdLabelName"), 'el':el}
		if( label.labelname ){
			this._gtdinboxPage.search(GIPROTOTYPE.searchableLabel(label.labelname));
		}
		return;
	}
	GIPROTOTYPE.stop(event);
	
	searchStr = this.parseSearchString(searchStr);
		
	this._gtdinboxPage.search(searchStr);
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard2 _clickLink\n" + e.toString());
}
};
Dashboard2.prototype.parseSearchString = function(searchStr){
	if( searchStr.indexOf("<gtdinbox.personalemail>")>-1 ){
		var personalSearch = GIPROTOTYPE.restrictSearchToUser(this._gtdinboxPage._environment.emails);
		searchStr = searchStr.replace( "<gtdinbox.personalemail>", personalSearch );
	}
	return searchStr;
};

Dashboard2.prototype.destroy = function(){
	this._eventObservers.destroy();
	this._gtdinboxPage = null;
	this._searcherNumberResults.destroy();
};