function Dashboard3(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = this._gtdinboxPage._labels;
	this._eventObservers = new GtdEventObservers(this);
	this._showHiders = {};
		
	this._searcherNumberResults = new Searcher(this._gtdinboxPage);
	
try{
	
	this.el = this._doc.createElement("DIV");
		this.el.className = "dashboard";
	
	this._dashboardContexts = new DashboardContexts(this._gtdinboxPage, this.el);
	this._dashboardContexts.addEventHandler(this, "change-context", this._changeContext);
	
	this.elCombos = this._doc.createElement("DIV");
		this.elCombos.className = "combos";
	this.el.appendChild( this.elCombos );
	
	this.createCombo("Tasks");
	this.createCombo("Reviews");
	this.createCombo("Projects");
	this.createCombo("Contacts");
	this.createCombo("Recent");
	
	var elClear = this._doc.createElement("DIV");
		elClear.style.clear = "both";
	this.elCombos.appendChild(elClear);
	
	var elClear = this._doc.createElement("DIV");
		elClear.style.clear = "both";
	this.el.appendChild(elClear);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard3 create\n" + e.toString());
}
}
Dashboard3.prototype.createCombo = function(name){
try{
	// Create a showhider, look up the title from the stringbundle, and store it in the showhiders collection
	var elContent = this._doc.createElement("DIV");
	var showHider = new ShowhiderCombo(this._gtdinboxPage, "Dashboard." + name, {title:this._gtdinboxPage.stringBundle.getString("Dashboard." + name), 'elContent':elContent, 'elParent':this.elCombos});
	showHider.addEventHandler(this, "show", this._showShowHider);
	
	this._eventObservers.observe(elContent, "click", this._clickShowHiderContent, false );
	
	showHider.name = name;
	this._showHiders[name] = showHider;
		
	return showHider;
	
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard3 createCombo\n" + e.toString());
}
};


Dashboard3.prototype.viewChange = function(gmail){
	// Ensure the Dashboard is integrated into this view
try{
	if( this._gtdinboxPage.view("view")!="tl" && this._gtdinboxPage.view("view")!="cv" ) return;
	
	var elHeader = this._gtdinboxPage.gmailDOM.element("actions-header");
	for( var i = 0; i < elHeader.childNodes.length; i++ ){
		if( GIPROTOTYPE.hasClassName(elHeader.childNodes[i], "dashboard") ) return;	// Already in
	}
	
	elHeader.insertBefore( this.el, elHeader.firstChild );
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard3 viewChange\n" + e.toString());
}
};

Dashboard3.prototype._changeContext = function(){
	// Hide all combos
	for( name in this._showHiders ) this._showHiders[name]._show(false);
};

















Dashboard3.prototype._showShowHider = function(showHider){
	// Refresh the view for this show hider
	
try{
	// Hide all the others
	for( name in this._showHiders ) if( this._showHiders[name]!=showHider && this._showHiders[name]._show() ) this._showHiders[name]._show(false);

	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;
	var projectPrefix = this._gtdinboxPage.settings.labels.types.Projects.prefix;
	var statusDefaults = this._gtdinboxPage.settings.labels.types.Statuses.defaults;
	var statusFinished = this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished;

	
	switch(showHider.name){
		case "Tasks":
			var parentSearch = GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " ";
			showHider.elContent.innerHTML = "";
			var statusLabels = this._labels.getLabelsArray("Statuses");
			var statusStr = parentSearch;
			for( var i = 0; i < statusLabels.length; i++ ) if(statusLabels[i]!=statusFinished) statusStr += ((i>0)? " OR ":"") + GIPROTOTYPE.searchableLabel(statusLabels[i]);
			statusStr += " -" + GIPROTOTYPE.searchableLabel(statusFinished);
			this._addItem( showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks.ShowAllTasks"), null, statusStr, null, true );
			
			var labels = GIPROTOTYPE.clone(this._labels.getLabelsArray("Statuses"));	
			var settingsStatus = this._gtdinboxPage.settings.labels.types.Statuses;
			var labelSearch = "";
			for( d in settingsStatus.defaults ){ // Process defaults
				var label = settingsStatus.prefix + settingsStatus.defaults[d];
				for( var i = 0; i < labels.length; i++ ){
					if( labels[i]==label ){
						if( d=="Action" ){
							labelSearch = "(" + GIPROTOTYPE.searchableLabel(label) + " OR " + GIPROTOTYPE.searchableLabel(settingsStatus.prefix + settingsStatus.defaults.NextAction) + ")";
						}else{
							labelSearch = GIPROTOTYPE.searchableLabel(label);
						}
						if( d!="Finished" ) labelSearch += parentSearch + " -" + GIPROTOTYPE.searchableLabel(statusFinished);
						var title = this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks." + d) || label.replace(settingsStatus.prefix, "");
						this._addItem( showHider.elContent, title, label, labelSearch, null, true );
						labels.splice(i,1);
						i--;
					}
				}
			}
			for( var i = 0; i < labels.length; i++ ){	// And the rest
				var label = labels[i];
				this._addItem( showHider.elContent, label.replace(settingsStatus.prefix,""), label, parentSearch + GIPROTOTYPE.searchableLabel(label) + " -" + GIPROTOTYPE.searchableLabel(statusFinished), null, true);
			}
			this._addItem( showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks.Personal"), null, parentSearch + "<gtdinbox.personalemail> " + GIPROTOTYPE.searchableLabel(statusPrefix + statusDefaults.Action) + " -" + GIPROTOTYPE.searchableLabel(statusFinished), null, true);
			
			this._searcherNumberResults.showNumberResultsForEl(showHider.elContent);
			break;
		case "Projects":
			// Read all unfinished actions that also have a project
			// Process, to see which projects rank highest (appear most)
			// Also store which projects have the oldest tasks and most recent
			// Rank
			
			var query = GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " -" + GIPROTOTYPE.searchableLabel(statusFinished) + " (";
			var labels = this._labels.getLabelsArray("Statuses");
			for( var i = 0; i < labels.length; i++ ){
				if( labels[i]!=statusFinished ) query += GIPROTOTYPE.searchableLabel(labels[i]) + " OR ";
			}
			query = query.replace(/ OR $/,"") + ") (";
			var labels = this._labels.getLabelsArray("Projects");
			for( var i = 0; i < labels.length; i++ ) query += GIPROTOTYPE.searchableLabel(labels[i]) + " OR ";
			query = query.replace(/ OR $/,")");
			
			this._projects = {};			
			this._createShowHiderContentForRankedActionBasedLabels(showHider, "Projects", query, this._projects);
			break;
		case "Contacts":
			// Read all unfinished actions
			// Process, to see which contacts rank highest (appear most)
			// Also store which contacts have the oldest tasks and most recent
			// Rank
			
			var query = GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " -" + GIPROTOTYPE.searchableLabel(statusFinished) + " (";
			var labels = this._labels.getLabelsArray("Statuses");
			for( var i = 0; i < labels.length; i++ ){
				if( labels[i]!=statusFinished ) query += GIPROTOTYPE.searchableLabel(labels[i]) + " OR ";
			}
			query = query.replace(/ OR $/,"") + ")";
			var after = new Date( (new Date()).valueOf() - (1000*60*60*24*90) );
			query += " after:" + after.getFullYear() + "/" + (after.getMonth() + 1) + "/" + after.getDate();
			
			this._contacts = {};
			this._createShowHiderContentForRankedActionBasedLabels(showHider, "Contacts", query, this._contacts);
			break;
		case "Recent":
			showHider.elContent.innerHTML = "";
			var projects = this._gtdinboxPage._recentItems.projects();
			if( projects.length > 0 ){
				this._addTitle(showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Recent.RecentProjects"));
				for( var i = 0; i < projects.length; i++ ){
					this._addItem(showHider.elContent, projects[i].replace(projectPrefix,""), projects[i], GIPROTOTYPE.searchableLabel(projects[i]) );
				}
			}
			
			var threads = this._gtdinboxPage._recentItems.threads();
			if( threads.length > 0 ){
				this._addTitle(showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Recent.RecentThreads"));
				for( var i = 0; i < threads.length; i++ ){
					this._addItem(showHider.elContent, threads[i].subject );
				}
			}
			
			if( threads.length==0 && projects.length==0 ){
				this._addTitle(showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Recent.NoItems"));
			}

			break;
		case "Reviews":
			var knownIds = {};
	
			var reviews = this._gtdinboxPage.settings.reviews;
			if( reviews ){
				var categories = {};
				
				for( var i = 0; i < reviews.length; i++ ){
					var title = reviews[i].title;
					if( !title && reviews[i].titleKey ) title = this._gtdinboxPage.stringBundle.getString(reviews[i].titleKey);
					
					var category = reviews[i].category;
					if( !category && reviews[i].categoryKey ) category = this._gtdinboxPage.stringBundle.getString(reviews[i].categoryKey);
					if( !category ) category = this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.Misc");
					
					var search = reviews[i].search;
					// Look for variables
					var variables = search.match(/<\?\=([^>]+?)>/g);
					if( variables ){
						for( var j = 0; j < variables.length; j++ ){
							var variableData = variables[j].match(/<\?\=([^>]+?)>/);
							if( variableData.length > 1 ){
								var args = variableData[1].split(".");
								var substitute = "";
								switch(args[0]){
									case "DaysAgo":
										substitute = GIPROTOTYPE.searchDate( (new Date()).valueOf() - (1000*60*60*24*parseInt(args[1])) );
										break;
									case "MonthsAgo":
										substitute = GIPROTOTYPE.searchDate( (new Date()).valueOf() - ((1000*60*60*24*31)*parseInt(args[1])) );
										break;
									case "DefaultStatus":
										substitute = GIPROTOTYPE.searchableLabel(statusPrefix + statusDefaults[args[1]]);
										break;
								}
								search = search.replace(variables[j], substitute);
							}
						}
					}
					
					if( title && !knownIds[reviews[i].id] ){
						if( !categories[category] )	categories[category] = this._addTitle(showHider.elContent, category);
						categories[category] = this._addItem(showHider.elContent, title, null, search, categories[category].nextSibling);
						knownIds[reviews[i].id] = true;
					}
				}		
			}
			
			// Add Modify
			this._addTitle( showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.Options"), true );
			var elModify = this._addItem( showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.ModifyReviews") );
			elModify.title = this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.ModifyReviews.Tooltip");
			elModify.style.fontStyle = "italic";
			elModify.setAttribute("gtd.act", "modifyreviews");
			
			break;
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard3 _showShowHider\n" + e.toString());
}
};
Dashboard3.prototype._createShowHiderContentForRankedActionBasedLabels = function(showHider, type, query, dataSet){
try{
	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;
	var projectPrefix = this._gtdinboxPage.settings.labels.types.Projects.prefix;
	var statusDefaults = this._gtdinboxPage.settings.labels.types.Statuses.defaults;
	var statusFinished = this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished;


	showHider.elContent.innerHTML = "<img src='chrome://gtdinbox/skin/indicator_medium.gif' class='loading'/>";

	
	
	
	var id = (new Date()).valueOf();
	dataSet._data = {'id':id};
	
	var searcher = new Searcher(this._gtdinboxPage);
	searcher.search(query, GIPROTOTYPE.bind(this, function(threadList){
			// Now process
			try{
			
			if( id!=dataSet._data.id ) return;	// Moved on
			
			// Parse the Data:
			var fParseThread = function(foundStatusLabels, thread, itemName, displayName){	// Populate the dataSet for this thread item (e.g. a project label on a thread)
				if( !dataSet[itemName] ) dataSet[itemName] = {matches:0,oldest:0,newest:0,statusMatches:{},'displayName':displayName};
				dataSet[itemName].matches++;
				for( var k = 0; k < foundStatusLabels.length; k++ ){
					if( !dataSet[itemName].statusMatches[foundStatusLabels[k]] ) dataSet[itemName].statusMatches[foundStatusLabels[k]] = 0;
					dataSet[itemName].statusMatches[foundStatusLabels[k]]++;
				}
				var d = thread.date();
				if( d ){
					d = d.valueOf();
					if( dataSet[itemName].oldest==0 ) dataSet[itemName].oldest = d;
					if( d < dataSet[itemName].oldest ) dataSet[itemName].oldest = d;
					if( d > dataSet[itemName].newest ) dataSet[itemName].newest = d;
				}
			};
			for( var i = 0; i < threadList._threads.length; i++ ){
				var thread = threadList._threads[i];
				var foundStatusLabels = [];
				for( var j = 0; j < thread.labels.length; j++ ) if( thread.labels[j].indexOf(statusPrefix)==0 ) foundStatusLabels.push(thread.labels[j]);
				
				
				switch(type){
					case "Projects":
						for( var j = 0; j < thread.labels.length; j++ ){
							if( thread.labels[j].indexOf(projectPrefix)==0 ){
								fParseThread(foundStatusLabels, thread, thread.labels[j]);
							}
						}
						break;
					case "Contacts":
						var names = thread.getNames(null, true);
						for( var j = 0; j < names.length; j++ ){
							fParseThread(foundStatusLabels, thread, names[j][1], names[j][0]);
						}
						break;
				}
			}
			
			// Create Rankable ShowHider ElContent:
			showHider.elContent.innerHTML = "";
			var elRankings = this._doc.createElement("DIV");
				elRankings.className = "rankings";
				elRankings.setAttribute("name", "gtd-ranking-" + type);
			
			var el = this._doc.createElement("DIV");
				el.className = "ranking";
				el.innerHTML = this._gtdinboxPage.stringBundle.getString("Dashboard.Rankings.Alphabetical");
				el.setAttribute("gtdRanking", "alphabetical");
			elRankings.appendChild( el );
			var el = this._doc.createElement("DIV");
				el.className = "ranking";
				el.innerHTML = this._gtdinboxPage.stringBundle.getString("Dashboard.Rankings.Tasks");
				el.setAttribute("gtdRanking", "tasks");
			elRankings.appendChild( el );
			var el = this._doc.createElement("DIV");
				el.className = "ranking";
				el.innerHTML = this._gtdinboxPage.stringBundle.getString("Dashboard.Rankings.Oldest");
				el.setAttribute("gtdRanking", "oldest");
			elRankings.appendChild( el );
		
			var elClear = this._doc.createElement("DIV");
				elClear.style.clear = "both";
			elRankings.appendChild(elClear);
			this._eventObservers.observe(elRankings, "mousedown", this._clickRanking, false);

			showHider.elContent.appendChild( elRankings );
			var elLineItems = this._doc.createElement("DIV");
				elLineItems.setAttribute("name", "gtd-combo-lineitems");
			showHider.elContent.appendChild( elLineItems );
			
			// Do Initial Ranking:
			this.rankActionBasedLabels(type, elRankings, "tasks", dataSet);
			
			
			}catch(e){
				if( GTDDEBUGMODE ) alert("Dashboard3 _createShowHiderContentForRankedActionBasedLabels callback\n" + e.toString());
			}
		}));
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard3 _createShowHiderContentForRankedActionBasedLabels\n" + e.toString());
}
};


Dashboard3.prototype._clickRanking = function(event, el){
	// Decide what ranking type was clicked; and process
	
try{
	if( !el ) el = GIPROTOTYPE.element(event);
	
	var elRankings = el.parentNode;
	if( elRankings.className!="rankings" ) return;
	
	
	switch( elRankings.getAttribute("name") ){
		case "gtd-ranking-Projects":
			this.rankActionBasedLabels( "Projects", elRankings, el.getAttribute("gtdRanking"), this._projects );
			break;
		case "gtd-ranking-Contacts":
			this.rankActionBasedLabels( "Contacts", elRankings, el.getAttribute("gtdRanking"), this._contacts );
			break;
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard3 _clickRanking\n" + e.toString());
}
};
Dashboard3.prototype.rankActionBasedLabels = function(type, elRankings, ranking, dataSet){
	// ranking - 'tasks'

try{	
	var elLineItems = GIPROTOTYPE.getElementsByChildName(elRankings.parentNode, "gtd-combo-lineitems")[0];
	
	// Change selected RankTitle:
	for( var i = 0; i < elRankings.childNodes.length; i++ ){
		var el = elRankings.childNodes[i];
		if( GIPROTOTYPE.hasClassName(el, "selected") ) GIPROTOTYPE.removeClassName(el, "selected");
		if( el.getAttribute("gtdRanking")==ranking ) GIPROTOTYPE.addClassName(el, "selected");
	}
		
	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;
	var sNextAction = statusPrefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.NextAction;
	var sAction = statusPrefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Action;
	var sWaitingOn = statusPrefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.WaitingOn;
	
	switch(type){
		case "Projects":
			// Sort the Data:
			var rankedProjects = [];
			var rankedProjectsHash = {};
			if( ranking=="alphabetical" ){
				for( p in dataSet ){
					if( p!="_data" ){
						rankedProjects.push(p);
						rankedProjectsHash[p] = p;
					}
				}
				rankedProjects.sort();
			}else if( ranking=="tasks" ){
				for( p in dataSet ){
					if( p!="_data" ){
						rankedProjects.push( GIPROTOTYPE.padZero(dataSet[p].matches, 5) + p );
						rankedProjectsHash[ GIPROTOTYPE.padZero(dataSet[p].matches, 5) + p ] = p;
					}
				}
				rankedProjects.sort().reverse();
			}else if( ranking=="oldest" ){
				for( p in dataSet ){
					if( p!="_data" ){
						rankedProjects.push( GIPROTOTYPE.padZero(dataSet[p].oldest, 20) + p );
						rankedProjectsHash[ GIPROTOTYPE.padZero(dataSet[p].oldest, 20) + p ] = p;
					}
				}
				rankedProjects.sort();
			}	
			// Render the ranked projects:
			elLineItems.innerHTML = "";
			for( var i = 0; i < rankedProjects.length; i++ ){
				var label = rankedProjectsHash[rankedProjects[i]];			
				this._addRankedItem(elLineItems, type, label, null, dataSet[ label ], GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " " + GIPROTOTYPE.searchableLabel(label));
			}
			break;
			
		case "Contacts":
			// Sort the Data:
			var rankedContactsOwe = [];
			var rankedContactsOweHash = {};
			var rankedContactsDelegated = [];
			var rankedContactsDelegatedHash = {};
			if( ranking=="alphabetical" ){
				for( p in dataSet ){
					if( p!="_data" ){
						rankedContactsOwe.push(dataSet[p].displayName + p);
						rankedContactsOweHash[dataSet[p].displayName + p] = p;
					}
				}
				rankedContactsDelegated.sort();
				rankedContactsOwe.sort();
			}else if( ranking=="tasks" ){
				for( p in dataSet ){
					if( p!="_data" ){
						if( dataSet[p].statusMatches[sWaitingOn] ){
							rankedContactsDelegated.push( GIPROTOTYPE.padZero(dataSet[p].statusMatches[sWaitingOn], 5) + p );
							rankedContactsDelegatedHash[ GIPROTOTYPE.padZero(dataSet[p].statusMatches[sWaitingOn], 5) + p ] = p;
						}
						var matches = (dataSet[p].statusMatches[sNextAction]||0) + (dataSet[p].statusMatches[sAction]||0);
						rankedContactsOwe.push( GIPROTOTYPE.padZero(matches, 5) + p );
						rankedContactsOweHash[ GIPROTOTYPE.padZero(matches, 5) + p ] = p;
					}
				}
				rankedContactsDelegated.sort().reverse();
				rankedContactsOwe.sort().reverse();
			}else if( ranking=="oldest" ){
				for( p in dataSet ){
					if( p!="_data" ){
						if( dataSet[p].statusMatches[sWaitingOn] ){
							rankedContactsDelegated.push( GIPROTOTYPE.padZero(dataSet[p].oldest, 20) + p );
							rankedContactsDelegatedHash[ GIPROTOTYPE.padZero(dataSet[p].oldest, 20) + p ] = p;
						}else{
							rankedContactsOwe.push( GIPROTOTYPE.padZero(dataSet[p].oldest, 20) + p );
							rankedContactsOweHash[ GIPROTOTYPE.padZero(dataSet[p].oldest, 20) + p ] = p;
						}
					}
				}
				rankedContactsDelegated.sort();
				rankedContactsOwe.sort();
			}	
			
			// Render the ranked contacts:
			elLineItems.innerHTML = "";
			if( rankedContactsDelegated.length>0 ) this._addTitle( elLineItems, this._gtdinboxPage.stringBundle.getString("Dashboard.Contacts.Owe") );
			for( var i = 0; i < rankedContactsOwe.length; i++ ){
				var contact = rankedContactsOweHash[rankedContactsOwe[i]];			
				this._addRankedItem(elLineItems, type, contact, null, dataSet[ contact ], GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " " + contact, dataSet[ contact ].displayName);
			}
			if( rankedContactsDelegated.length>0 ){
				this._addTitle( elLineItems, this._gtdinboxPage.stringBundle.getString("Dashboard.Contacts.Delegated") );
				for( var i = 0; i < rankedContactsDelegated.length; i++ ){
					var contact = rankedContactsDelegatedHash[rankedContactsDelegated[i]];			
					this._addRankedItem(elLineItems, type, contact, dataSet[contact].statusMatches[sWaitingOn], dataSet[ contact ], GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " " + contact, dataSet[ contact ].displayName);
				}
			}
			break;
	}
	
	
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard3 processProjectsComboByRanking\n" + e.toString());
}
};


Dashboard3.prototype._addTitle = function(elCombo, title, superTitle){
	var el = this._doc.createElement("OPTION");
		el.className = "title";
	el.innerHTML = title;
	
	if( superTitle ) el.className += " super-title";
	
	elCombo.appendChild( el );
	return el;
};

Dashboard3.prototype._addItem = function(elCombo, title, labelName, search, insertBefore, showNumberResults){
	var el = this._doc.createElement("OPTION");
		el.className = "line-item";
		if( !labelName ) labelName = "";
		el.setAttribute("gtdLabelName", labelName);
		if( !search ) search = labelName;
		el.setAttribute("gtdSearch", search);
	el.innerHTML = title;
	if( showNumberResults ) el.setAttribute("show-number-results", "1");
	
	if( insertBefore ){
		elCombo.insertBefore( el, insertBefore );
	}else{
		elCombo.appendChild( el );
	}
	
	return el;
};

Dashboard3.prototype._addRankedItem = function(elCombo, type, label, actionCount, dataItem, search, displayName){
	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;
	var sNextAction = statusPrefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.NextAction;
	var sAction = statusPrefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Action;
	var sWaitingOn = statusPrefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.WaitingOn;
	var sSomeday = statusPrefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Someday;

	var el = this._doc.createElement("DIV");
	el.className = "line-item";
	el.setAttribute("gtdLabelName", label);
	el.setAttribute("gtdSearch", search );
	
	var oldest = new Date(dataItem.oldest);
	var newest = new Date(dataItem.newest);
	var daysAgo = parseInt(((new Date()).valueOf() - dataItem.oldest) / (1000*60*60*24));
	
	
	var title = [label + ": "];
	title.push( (dataItem.statusMatches[sNextAction]||0) + (dataItem.statusMatches[sAction]||0) + " " + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.Action") + ", " );
	title.push( (dataItem.statusMatches[sWaitingOn]||0) + " " + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.WaitingOn") + ", " );
	title.push( (dataItem.statusMatches[sSomeday]||0) + " " + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.Someday") );
	el.title = title.join("");
	
	if( actionCount==null ) actionCount = ((dataItem.statusMatches[sNextAction]||0) + (dataItem.statusMatches[sAction]||0));
	var html = [];
	html.push( "<div><div class='left'>" + (displayName || label) + " (" + actionCount + ")</div><img class='expander' src='chrome://gtdinbox/content/filter-extend.png' gtdSearch='" + search + "' gtdType='" + type + "' gtdName='" + label + "' /><div style='clear:both'></div>");
	html.push( "<div class='details'>" + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.Since") + " " + daysAgo + " " + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.DaysAgo") + "</div>");
	el.innerHTML = html.join("");
	
	elCombo.appendChild( el );
};







Dashboard3.prototype._clickShowHiderContent = function(event){
	if( event.button!=0 ) return;
	
	
	var el = GIPROTOTYPE.element(event);
	
	
	
	if( el.getAttribute("gtd.act")=="modifyreviews" ){
		this._gtdinboxPage._lightbox.setType( "modifyreviews" );
		this._gtdinboxPage._lightbox.active(true);
		return;
	}
	
	var searchStr = el.getAttribute("gtdSearch");
	if( !searchStr ){
		var label = {name:el.getAttribute("gtdName"), labelname:el.getAttribute("gtdLabelName"), 'el':el}
		if( label.labelname ){
			this._gtdinboxPage.search(GIPROTOTYPE.searchableLabel(label.labelname));
		}
		return;
	}
	GIPROTOTYPE.stop(event);
	
	searchStr = GIPROTOTYPE.parseSearchString(searchStr);
		
	this._gtdinboxPage.search(searchStr);
};





Dashboard3.prototype.destroy = function(){
	this._eventObservers.destroy();
	this._gtdinboxPage = null;
	this._searcherNumberResults.destroy();
	
	for( name in this._showHiders ){
		this._showHiders[name].destroy();
	}
};