/* Copyright Andy Mitchell 2007. No warranties */

function GmailDOM(gtdinboxPage, gmail){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._window = gtdinboxPage.window;
	this._xmlHttpRequest = new GIXMLHttpRequest(gtdinboxPage);
	this._gmail = gmail;
}

GmailDOM.prototype.viewChange = function(gmail){
	this._gmail = gmail;
};

GmailDOM.prototype.element = function(name, gmail, doc, elActive){
try{


	gmail = (gmail && (typeof gmail!="undefined"))? gmail : this._gmail;
	this._gmail = gmail;
	if( gmail["get" + name] ) return gmail["get" + name]();
	
	doc = doc || this._doc;
	
	if( !elActive ){
		var elActive = gmail.getActiveViewElement();
		if( !elActive ){
			if( this._window && this._window.frames && this._window.frames[1] && this._window.frames[1].document ){
				elActive = this._window.frames[1].document.body;
			}else{
				elActive = doc.body;
			}
		}
		if( !elActive ) return;
	}
	
	
	switch(name){
		/* GENERAL */
		case "window":
			return elActive.ownerDocument.defaultView;
			break;
		case "document":
			return elActive.ownerDocument;
			break;
		case "action-combo":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='QOD9Ec']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "tasks-combo":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//select[starts-with(@class,'dashboard-combo-tasks')]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "reviews-combo":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//select[starts-with(@class,'dashboard-combo-reviews')]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "action-combo-bottom":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='QOD9Ec']", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			if( result.snapshotLength>0 ) return result.snapshotItem(result.snapshotLength-1);
			break;
		case "action-combo-list":
			var result = doc.evaluate("//div[@class='Sn99bd']", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			for( var i = 0; i < result.snapshotLength; i++ ){
				if( result.snapshotItem(i).style.visibility!="hidden" ) return result.snapshotItem(i);
			}
			//return result.singleNodeValue;			
			break;
		case "email-address":
			var result = doc.evaluate("//div[@class='XoqCub']//div[@class='nQ6QTe']//nobr//b", doc.body, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "alert-box":
			var result = doc.evaluate("//div[@class='n38jzf']//table[@class='cyVRte']//td[@class='m14Grb']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "search-box":
			var result = doc.evaluate("//div[@class='oF1kyb']//div[@class='tYBwhe']//input[@type='text']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "search-button":
			var result = doc.evaluate("//div[@class='oF1kyb']//div[@class='tYBwhe']//button[@type='button']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "search-row":
			var result = doc.evaluate("//div[@class='IY0d9c']//div[@class='XoqCub EGSDee']//div[@class='oF1kyb']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			var el = result.singleNodeValue;
			return el? el.parentNode : null;
			break;
		case "actions-header":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='yCMBJb S6g97b']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			if( !result.singleNodeValue ) result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='jsbnre yCMBJb']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "search-text":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='sGcZQb']//div[@class='opbAfb']//div[@class='zXXI1']//span", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "search-print":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@name='gtd-print']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "threadlist-range":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='zlqE9']//div[@class='bSwwie']//span[@class='vZFPPc']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
			
		/* THREAD LIST */
		
		case "archive-button":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//button[@act='7']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "archive-button-footer":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='QCouhb yCMBJb']//button[@act='7']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "spam-button":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//button[@act='9']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "delete-button":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//button[@act='10']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "threadlist-refresh":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@act='20']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "new-label-box":
			var result = doc.evaluate("//div[@class='jY0YJb']//div[@class='tQzAEe']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			var el = result.singleNodeValue;
			if( el ) el = el.parentNode;
			return el;
			break;
			
		/* NAVIGATION */
		case "nav-buckets":
			var result = doc.evaluate("//div[@class='XoqCub EGSDee']//div[@class='XoqCub ybaOyc']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "inbox-link":
			var result = doc.evaluate("//div[@class='diLZtc']//div[starts-with(@class,'yyT6sf')]//a[@class='zD5BAe']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "compose-mail":
			var result = doc.evaluate("//div[@class='diLZtc']//div[@class='NIPhib']//span[@class='zD5BAe']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "labels-box":
			var result = doc.evaluate( "//div[@class='XoqCub XPj4ef']//div[@class='R7iiN c1norb']//div[@class='nb1Q2b']//div[@class='pvSW6e']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "labels-table":
			var result = doc.evaluate( "//div[@class='XoqCub XPj4ef']//div[@class='R7iiN c1norb']//div[@class='nb1Q2b']//div[@class='pvSW6e']//table[last()]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;	
			break;
		case "edit-labels":
			var result = doc.evaluate("//div[@class='diLZtc']//div[@class='nb1Q2b']//a[starts-with(@class,'Q9o7yd')]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			if( !result.singleNodeValue ) result = doc.evaluate("//div[@class='diLZtc']//div[@class='nb1Q2b']//div[starts-with(@class,'Q9o7yd')]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		
		

		/* CONVERSATION */
		case "conversation-header":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//td[@class='eWTfhb']//h1[@class='YfMhcb']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "conversation-subject":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//td[@class='eWTfhb']//h1[@class='YfMhcb']//span[@class='VrHWId']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "conversation-messages":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='XoqCub aWL81']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "conversation-below-reply":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'CNf1Cd')]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		/*
		case "conversation-reply-row":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'CNf1Cd InqsWb')]//div[@class='eNXyxd']//table[@class='EWdQcf']//tr", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "conversation-reply-reply":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'CNf1Cd InqsWb')]//div[@class='eNXyxd']//table[@class='EWdQcf']//td", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "conversation-reply-forward-firstchild":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'CNf1Cd InqsWb')]//div[@class='eNXyxd']//table[@class='EWdQcf']//td//div[@class='XymfBd X5Xvu']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "conversation-reply-self":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'CNf1Cd InqsWb')]//div[@class='eNXyxd']//table[@class='EWdQcf']//td//div[@class='reply-to-self']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "conversation-reply-messagetable":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'CNf1Cd InqsWb')]//div[@class='uQLZXb']//form//table[@class='wHcYVb']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		*/
		
		/* COMPOSE */
		case "rich-textarea":
			var elBody = null;
			var w = this.element("window");
			for( var i = 0; i < w.frames.length; i++ ){
				if( w.frames[i].document.body.className.indexOf("editable")>-1 ){
					elBody = w.frames[i].document.body;
					break;
				}
			}
			return elBody;
			break;
		case "plain-textarea":
			var result = doc.evaluate("//td[@class='opUkHb']//textarea[@class='iE5Yyc']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "compose-to":
			var result = doc.evaluate("//div[@class='uQLZXb']//form//table[@class='wHcYVb']//textarea[@class='mMl8gd']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "compose-subject":
			var result = doc.evaluate("//div[@class='uQLZXb']//form//table[@class='wHcYVb']//td[@class='J14TS']//input[@class='rSfjbb']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "compose-table":
			var result = doc.evaluate("//div[@class='uQLZXb']//form//table[@class='wHcYVb']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;	
		case "compose-send-first":
			var result = doc.evaluate("//div[@class='LlWyA c1I77d']//button[1]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
		case "compose-send-second":
			var result = doc.evaluate("//div[@class='CoUvaf c1I77d']//button[1]", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;	
			
			
		
		
		/* CONTACTS */
		case "contacts-iframe":
			var els = doc.getElementsByTagName("IFRAME");
			for( var i = 0; i < els.length; i++ ){
				if( els[i].getAttribute("src") && els[i].getAttribute("src").indexOf("/ContactManager")>-1 ){
					return els[i];
				}
			}
			break;
		case "contacts-frame-body":
			var w = this.element("window");
			for( var i = 0; i < w.frames.length; i++ ){
				if( w.frames[i].location.href.indexOf("ui/ContactManager")>-1 ){
					return w.frames[i].document.body;
				}
			}
			
			// Earlier code (to remove if stable)
			var w = this._window.frames[1];
			for( var i = 0; i < w.frames.length; i++ ){
				if( w.frames[i].location.href.indexOf("ui/ContactManager")>-1 ){
					return w.frames[i].document.body;
				}
			}
			break;
		case "contacts-manager-tabs":
			return doc.getElementById("manager-group-list");
			break;
		case "contacts-manager-list":
			return doc.getElementById("manager-contact-list");
			break;
		case "contacts-pane":
			return doc.getElementById("contact-pane");
			break;
			
		/* SETTINGS */
		case "settings-header":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='XoqCub wS5rZb hCyPr']//div[@class='XoqCub GVhBfc']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "labels-create-box":
			var result = doc.evaluate("//div[@class='XoqCub eGbrz']//tr[@class='GorKne']//td[@class='kN8OP']//input", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
		case "labels-last-row":
			var result = doc.evaluate("//div[@class='XoqCub eGbrz']//tr[last()]//td[@class='lKvq2e']", elActive, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			return result.singleNodeValue;
			break;
	}

}catch(e){
	if( GTDDEBUGMODE ) alert("gmaildom element\n" + e.toString());
}

};

GmailDOM.prototype.elements = function(name, gmail, doc, elActive){
try{
	gmail = (gmail && (typeof gmail!="undefined"))? gmail : this._gmail;
	this._gmail = gmail;
	
	doc = doc || this._doc;
	elActive = elActive || gmail.getActiveViewElement();
	switch(name){
		case "threadlist-allrows":
			return doc.evaluate( "//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d')]", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			break;
		case "threadlist-rows-lastcol":
			return doc.evaluate( "//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d')]//td[last()]", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			break;
		case "threadlist-rows-checkbox":
			return doc.evaluate( "//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d')]//td//input[@type='checkbox']", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			break;
		case "threadlist-rows-checked-checkbox":
			var xpath = "//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d AnqB9d rfza3e')]//td//input[@type='checkbox']";
			xpath += " | //div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d QhHSYc rfza3e')]//td//input[@type='checkbox']";
			var result = doc.evaluate( xpath, elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			return result;
			break;
		case "contacts-list":
			return doc.evaluate( "//div[starts-with(@class,'row')]//div[@class='check']//input[@type='checkbox']", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			break;
		case "contacts-list-checked":
			return doc.evaluate( "//div[starts-with(@class,'row selected')]//div[@class='check']//input[@type='checkbox']", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			break;
		case "action-combo-lists":
			var result = doc.evaluate("//div[@class='Sn99bd']", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			return result;
			break;
		case "labels-box-label-names":
			var result = doc.evaluate( "//div[@class='XoqCub XPj4ef']//div[@class='R7iiN c1norb']//div[@class='nb1Q2b']//div[@class='pvSW6e']//tr//a[@class='zD5BAe']", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			if( !result || result.snapshotLength==0 ){	// Old style
				var result = doc.evaluate( "//div[@class='XoqCub XPj4ef']//div[@class='R7iiN c1norb']//div[@class='nb1Q2b']//div[@class='pvSW6e']//tr//span", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			}
			return result;
			break;
		case "conversation-reply-rows":
			var result = doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[@class='eNXyxd']//table[@class='EWdQcf']//tr", elActive, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			return result;
			break;
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("gmaildom elements\n" + e.toString());
}	
}

GmailDOM.prototype.parseElement = function(name, el){
try{
	var result = {};
	//if( !el ) return;
	switch(name){
		case "threadlist-range": // el is SPAN, extract start range, end range, and number of messages
			var m = el.innerHTML.match(/<b>(.+?)<\/b>/g);
			var range = {start:0, end:0, count:0};
			if( m ){
				range.start = m[0].match(/<b>(.+?)<\/b>/)[1];
				range.end = m[1].match(/<b>(.+?)<\/b>/)[1];
				range.count = m[2].match(/<b>(.+?)<\/b>/)[1];
			}
			if( range.start > 0 ) range.start--;
			return range;
			break;
		case "thread-list-index":
			var result = this.elements("threadlist-rows-checkbox");
			var indices = [];
			for( var i = 0; i < result.snapshotLength; i++ ){
				if( result.snapshotItem(i).checked ) indices.push(i);
			}
			return indices;
			break;
		case "thread-list-row":	// el is TR; extract check, names, label, subject, snippet, date
			var elTds = el.getElementsByTagName("TD");
			result.elCheck = elTds[0].getElementsByTagName("INPUT")[0];
			result.elStar = elTds[1].getElementsByTagName("IMG")[0];
			result.names = [];
			result.messageCount = 0;
			var elSpans = elTds[2].getElementsByTagName("SPAN");
			for( var i = 0; i < elSpans.length; i++ ){
				if( elSpans[i].getAttribute("email") ){
					if( !result.messageCount ){	// Get the message count from brackets
						var elNames = elSpans[i].parentNode;
						var m = elNames.innerHTML.match(/\((\d+)\)\s*$/);
						if( !m || m.length==1 ) result.messageCount = 1;
						else result.messageCount = m[1];
					}
					result.names.push( [GIPROTOTYPE.decodeEntities(elSpans[i].innerHTML.replace(/<.+?>/g,"").replace(/\(\d+\)$/,"").replace(/\s?\.\s?$/,"")), GIPROTOTYPE.realEmail(elSpans[i].getAttribute("email"))] );
				}
			}
			result.labels = [];
			var elSpans = elTds[4].getElementsByTagName("SPAN");
			for( var i = 0; i < elSpans.length; i++ ){
				if( elSpans[i].className=="s75Nkf" ){	// it's a label (lots of b tags inside)
					result.labels.push( GIPROTOTYPE.trim(GIPROTOTYPE.decodeEntities(elSpans[i].innerHTML.replace(/<.+?>/g, ""))) );
				}
				if( elSpans[i].className=="bEeVec" ){	// it's snippet, and one before is subject
					var elPreviousSpan = elSpans[i];
					while( elPreviousSpan.previousSibling ){
						elPreviousSpan = elPreviousSpan.previousSibling;
						if( elPreviousSpan.nodeName=="SPAN" ){
							result.subject = GIPROTOTYPE.trim(GIPROTOTYPE.decodeEntities(elPreviousSpan.innerHTML.replace(/<.+?>/g, "")));
						}
					}
					result.snippet = GIPROTOTYPE.trim(GIPROTOTYPE.decodeEntities(elSpans[i].innerHTML.replace(/<.+?>/g, "")));
				}else if( elSpans[i].parentNode.className=="HhG5wd" && elSpans[i].parentNode.childNodes.length==1 ){	// Subject, but no snippet (empty msg)
					result.subject = GIPROTOTYPE.trim(GIPROTOTYPE.decodeEntities(elSpans[i].innerHTML.replace(/<.+?>/g, "")));
				}
			}
			if( result.subject ) result.subject = result.subject.replace(/\s*?\(\d+.+?\)$/, "");	// strip things like Chat (177 lines); because thread code doesn't use it
			result.elDate = elTds[6].getElementsByTagName("SPAN")[0];
			result.date = result.elDate.innerHTML.replace(/<.+?>/g, "");
			result.fullDate = result.elDate.getAttribute("title");
			
			if( result.labels.length==0 && !result.subject ){	// pre-coloured-labels
			}
			break;
		case "contacts-list-item":	// el can be div text, div check, or input box - find parent 'row', and then extract contents
			var i = 0; 
			while( el.parentNode && i++<=4 ){
				if( el.className.indexOf("row")>-1 ) break;
				el = el.parentNode;
			}
			if( el.className.indexOf("row")==-1 ) return;
			var row = [];
			for( var i = 0; i < el.childNodes.length; i++ ){
				if( el.childNodes[i].className=="text" ){
					row[1] = el.childNodes[i].title;
					row[0] = el.childNodes[i].innerHTML;
					break;
				}
			}
			var els = el.getElementsByTagName("INPUT");
			row[2] = els[0];
			return row;
			break;
		case "conversation-reply-row":
			// Pass a TR of the row
			// Extract tab items
			var row = {};
			var elTDs = el.getElementsByTagName("TD");
			if( elTDs.length==0 ) return;
			row.elReply = elTDs[0];
			row.elReplyToClick = row.elReply.getElementsByTagName("SPAN")[0];
			row.elForward = elTDs[2];
			for( var i = 0; i < elTDs.length; i++ ){
				if( elTDs[i].firstChild && elTDs[i].firstChild.className=="reply-to-self" ){
					row.elReplyToSelf = elTDs[i];
					break;
				}
			}
			// Find the table
			var elTree = el;
			while( elTree.parentNode && elTree.className!="eNXyxd" ) elTree = elTree.parentNode;
			if( elTree.className=="eNXyxd" ){
				elTree.className = "gtdinbox-tmp-conversation " + elTree.className;
			}

			var result = this._doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'gtdinbox-tmp-conversation')]//div[@class='uQLZXb']//form//table[@class='wHcYVb']", this._doc.body, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			row.elTable = result.singleNodeValue
			var result = this._doc.evaluate("//div[@gtdviewid='" + this._gtdinboxPage.view("gtdviewid") + "']//div[starts-with(@class,'gtdinbox-tmp-conversation')]//button//b", this._doc.body, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
			row.elSendButton = result.singleNodeValue
			if( row.elSendButton ) row.elSendButton = row.elSendButton.parentNode;
			
			elTree.className = elTree.className.replace("gtdinbox-tmp-conversation", "");

			if( row.elTable ){
				var elTRs = row.elTable.getElementsByTagName("TR");
				row.elFrom = elTRs[0];
				row.elTo = elTRs[1];
				row.elText = row.elTo.getElementsByTagName("TEXTAREA")[0];
			}
			
			return row;
						
			break;
	}
	
	return result;
}catch(e){
	if( GTDDEBUGMODE ) alert("gmaildom parseElement\n" + e.toString());
}
};

GmailDOM.prototype.test = function(name, el){
try{
	//var result = {};
	switch(name){
		case "is-sent-mail":
			var elNav = this.element("nav-buckets");
			var elSentMail = elNav.firstChild.childNodes[3];
			if( elSentMail.className.indexOf("cBhtOe")>-1 ){	// selected
				return true;
			}
			break;
		case "thread-row-unread":
			return (el.className.indexOf("QhHSYc")>-1);
			break;
		case "thread-row-checked":
			var elInputs = el.getElementsByTagName("INPUT");
			for( var i = 0; i < elInputs.length; i++ ){
				if( elInputs[i].getAttribute("type")=="checkbox" ){
					return elInputs[i].checked;
				}
			}
			break;
		case "thread-row":
			return (el.nodeName=="TR" && el.className.indexOf("xweT7d")==0);
			break;
		case "conversation-x":
			return (el.nodeName=="SPAN" && el.className=="tcLg2b");
			break;
		case "star":
			return ( el.nodeName=="IMG" && (el.className.indexOf("v0AEPd")>-1 || el.className.indexOf("n1QcP")>-1 || el.className.indexOf("QgQaBc")>-1 || el.className.indexOf("kyZrld")>-1) );	// It's a star image
			break;
		case "star-on":
			return (  el.className.indexOf("n1QcP")>-1 || el.className.indexOf("kyZrld")>-1 || (el.className.indexOf("kJv9nb")>-1 || el.parentNode.className.indexOf("n1QcP")>-1) );	// It's a star image
			break;
		case "contact-tab":
			if( el.nodeName=="DIV" && el.className=="text"){
				var found = false;
				var i = 0;
				while( i++ <=3 ){
					el = el.parentNode;
					if( el.id=="manager-group-list" ) return true;
				}
			}
			break;
		case "contacts-list-item-checkbox":
			return ( el.nodeName=="INPUT" && el.id.indexOf("CC")==0 && el.type.toLowerCase()=="text");	
			break;
		case "contacts-list-item-name":
			return ( el.nodeName=="DIV" && el.className=="text" && el.title.indexOf("@")>-1 );	
			break;
		case "conversation-reply-clicked-item":
			return (el.nodeName=="SPAN");
			break;
	}	
}catch(e){
	if( GTDDEBUGMODE ) alert("gmaildom test\n" + e.toString());
}
};


GmailDOM.prototype.extractSearchQuery = function(url){
	if( !url ) url = this._gtdinboxPage.unsafeWindow.top.location.href;
	url = url.replace(/\+/g, " ");
	url = decodeURIComponent(url);
	
	
	var elSearch = this.element("search-text");
	if( /\/(#search)/.test(url) ){
		var match = url.match( /\/#search\/(.+?)($|\/\w+$)/ );
		if( match ) return match[1];
	}else if( /\/(#label)/.test(url) ){
		var match = url.match( /\/#label\/(.+?)($|\/\w+$)/ );
		if( match ) return GIPROTOTYPE.searchableLabel( match[1] );
	}else if( elSearch && elSearch.innerHTML ){
		return elSearch.innerHTML;
	}else{
		// #inbox -> in:inbox, #sent -> in:sent, #all -> , #spam -> in:spam, #trash -> in:trash, #chats -> is:chat, #starred -> is:starred,
		if( /#inbox/.test(url) ) return "in:inbox";
		if( /#sent/.test(url) ) return "in:sent";
		if( /#spam/.test(url) ) return "in:spam";
		if( /#chats/.test(url) ) return "is:chat";
		if( /#starred/.test(url) ) return "is:starred";
	}	
	return "";
};


GmailDOM.prototype.search = function(query, threadList, currentOffset, number, callback, callbackFinish){
	//http://mail.google.com/mail/?ui=2&ik=20dd9d8458&view=tl&start=0&num=25&rt=h&q=test&search=query
	var url = this.local("domain") + "?ui=2&ik=" + this.local("ik") + "&rt=j&start=" + currentOffset + "&num=" + number + "&search=query&view=tl&q=(" + encodeURIComponent(query) + ")";
	
	var query = query;
	var rCallback = GIPROTOTYPE.bind(this, function(req){
				// Extract the json from the response
				
				
				var searchArray = null;
				var js = req.responseText.replace("while(1);", ""); //.replace(/_A\(.*?\)/g, "0");
				
				// Now need to patch the case of uneven []. Happens when free search (e.g. "hi chengdu"). Gmail provides an array that looks like, [["hi", 1), ["chengdu", 1)]. Brackets need swapping.
										
				
				//var m = js.match(/\[\"ti\"((.|\r|\n|\t|\e|\f|\a|\v)+?)\[\"tb\"/);
				var m = js.match(/\[\"ti\"([\w\W\d\s\b\r\n\t\e\f\a\v]+?)\[\"tb\"/);
				if( m ){
					var update = m[0].replace(/(,\d+)\)/g, "$1]");
					js = js.replace(m[0], update);
				}else{
				}
				
								
				try{
					if( this._gtdinboxPage.unsafeWindow.evalGTD ){	// can use overridden eval
						searchArray = this._gtdinboxPage.unsafeWindow.eval( "(" + js + ")" );
					}else{
						searchArray = this._gtdinboxPage.safelyEval(js);
					}
				}catch(e){
					if( GTDDEBUGMODE ) alert("GmailDOM search callback\n" + e.toString());
				}
				
				
				if(callback) callback(searchArray, query, threadList, currentOffset, callbackFinish);
				
		});
	this._xmlHttpRequest.process(url, null, rCallback);
};

GmailDOM.prototype.getThreadData = function(threadIds, threadList, callback){
	if( threadIds.length==0 ){
		if( callback ) callback();
		return;
	}
	var url = this.local("domain") + "?ui=2&ik=" + this.local("ik") + "&view=cv&th=" + threadIds.join("&th=") + "&prf=1&rt=j&search=query&q=";
	var rCallback = GIPROTOTYPE.bind(this, function(req){
				// Extract the json from the response			
				var searchArray = null;
				var js = req.responseText.replace("while(1);", ""); //.replace(/_A\(.*?\)/g, "0");
				try{
					if( this._gtdinboxPage.unsafeWindow.evalGTD ){	// can use overridden eval
						searchArray = this._gtdinboxPage.unsafeWindow.eval(js);
					}else{
						searchArray = this._gtdinboxPage.safelyEval(js);
					}
					threadList.parseAjaxResponse(searchArray[0]);
				}catch(e){
					if( GTDDEBUGMODE ) alert("GmailDOM getThreadData callback\n" + e.toString());
				}
				
				if(callback) callback(threadIds, threadList, searchArray);
		});
	this._xmlHttpRequest.process(url, null, rCallback);
};

GmailDOM.prototype.addLabel = function(names, callback, finalCallback){
try{
	if( typeof names=="string" ) names = [names];
	
	var count = {i:0};
	for( var i = 0; i < names.length; i++ ){
		var request = {};
		request.url = this.local("domain") + "?ui=2";
		request.url += "&ik=" + this.local("ik");
		request.url += "&at=" + this.local("at");
		request.url += "&view=up&act=cc_" + encodeURI(names[i]) + "&rt=h";
		request.callback = GIPROTOTYPE.bind(this, function(){
					if(callback) callback();
					if( --count.i==0 ){
						if(finalCallback) finalCallback();
					}
			});
		count.i++;
		this._xmlHttpRequest.queueAndProcess(request);
	}
}catch(e){
	alert("gmaildom addLabel\n" + e.toString());
}
};
GmailDOM.prototype.renameLabel = function(replacements, callback, finalCallback){
try{
	if( typeof replacements[0]=="string" ) replacements = [replacements];	// should be [[,],[,]]
	
	var count = {i:0};
	for( var i = 0; i < replacements.length; i++ ){
		var request = {};
		request.url = this.local("domain") + "?ui=2";
		request.url += "&ik=" + this.local("ik");
		request.url += "&at=" + this.local("at");
		request.url += "&view=up&act=nc_" + encodeURI(replacements[i][0]) + "%5E" + encodeURI(replacements[i][1]) + "&rt=h";
		request.callback = GIPROTOTYPE.bind(this, function(){
				if(callback) callback();
				if( --count.i==0 ){
					if(finalCallback) finalCallback();
				}
			});
		count.i++;
		this._xmlHttpRequest.queueAndProcess(request);
	}
}catch(e){
	alert("gmaildom renameLabel\n" + e.toString());
}
};
GmailDOM.prototype.addLabelToThread = function(threadId, label, finalCallback){
try{

	var request = {};
	request.url = this.local("domain") + "?ui=2";
	request.url += "&ik=" + this.local("ik");
	request.url += "&at=" + this.local("at");
	request.url += "&view=up&act=ac_" + encodeURI(label) + "&rt=j&search=inbox&t=" + threadId + "&";
	request.callback = finalCallback
	this._xmlHttpRequest.queueAndProcess(request);

}catch(e){
	alert("gmaildom addLabel\n" + e.toString());
}
};
GmailDOM.prototype.removeLabelFromThread = function(threadId, label, finalCallback, thread){
try{

	// For some reason, Gmail likes the last message id; rather than the first it normally uses.
	if( !thread ){
		this._gtdinboxPage._threadList.getThreadById(threadId, GIPROTOTYPE.bind(this, function(thread){
				//if( !thread ) thread = new Thread(this._gtdinboxPage._threadList, threadId);
				this.removeLabelFromThread(threadId, label, finalCallback, thread);
			}), true);
		return;
	}

	
	var id = threadId;
	var msg = thread.getLastMessage();
	if( msg ) id = msg.id;	// Use first
	
	var request = {};
	request.url = this.local("domain") + "?ui=2";
	request.url += "&ik=" + this.local("ik");
	request.url += "&at=" + this.local("at");
	request.url += "&view=up&act=rc_" + encodeURI(label) + "&rt=j&search=inbox&t=" + id + "&";
	request.callback = finalCallback
	this._xmlHttpRequest.queueAndProcess(request);

}catch(e){
	alert("gmaildom addLabel\n" + e.toString());
}
};

GmailDOM.prototype.refreshView = function(){

	if( this._gtdinboxPage.view("view")=="tl"){
		var elRefresh = this.element("threadlist-refresh");
		if( elRefresh ) GIPROTOTYPE.doMouseEvent(this._doc, elRefresh, "click");
	}else{
		var el = this.element("inbox-link");
		setTimeout( GIPROTOTYPE.bind(this, function(){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "click");	// refresh
		}), 2000 );
	}
};

GmailDOM.prototype.local = function(name){
try{
	var failStr = "";
	switch(name){
		case "domain":
			return this._gtdinboxPage.doc.location.href.match(/^http(s?):\/\/mail.google.com\/(a\/.+?\/|.+?\/)/)[0];
		case "ik":
			if( this._gtdinboxPage.unsafeWindow ){
				if( this._gtdinboxPage.unsafeWindow.top.js.ID_KEY ){
					return this._gtdinboxPage.unsafeWindow.top.js.ID_KEY;
				}
				if( this._gtdinboxPage.unsafeWindow.top.js.GLOBALS[9] ){
					return this._gtdinboxPage.unsafeWindow.top.js.GLOBALS[9];
				}
				
			}
			return this._gtdinboxPage.unsafeWindow? this._gtdinboxPage.unsafeWindow.top.js.ID_KEY : "";
		case "at":
			if( !this._gtdinboxPage.unsafeWindow ) return;
			var cookie = this._gtdinboxPage.unsafeWindow.document.cookie;
			var m = cookie.match(/GMAIL_AT\=([\d\w]+?);/i);
			if( m && m.length>0 ) return m[1];
		
			if( !this._gtdinboxPage.unsafeWindow.top.js._GM_chatEngine ) return "";
			
			var testAt = function(str){
				if( !str ) return false;
				if( str.length>28 ){
					if( (/^[a-zA-Z0-9_\-]+$/.test(str)) ){
						return true;
					}
				}
				return false;
			};
			
			var ce = this._gtdinboxPage.unsafeWindow.top.js._GM_chatEngine;
			var at = ce.bfb;
			if( !testAt(at) && ce.bob && ce.bob.gqb && ce.bob.gqb.vm ) at = ce.bob.gqb.vm.at;
			if( !at || !testAt(at) ) at = ce.Fdb;
			if( !testAt(at) ) at = ce.Ehb;
			if( (!testAt(at)) && ce.MB && !(typeof ce.MB=="function") ) at = ce.MB.Fdb;
			//if( (!testAt(at)) && ce.mEb && ce.mEb.rGb && ce.mEb.rGb.pr ) at = ce.mEb.rGb.pr.at;
			if( (!testAt(at)) && ce.mEb && !(typeof ce.mEb=="function") ){
				if( ce.mEb.rGb && !(typeof ce.mEb.rGb=="function") ){
					if( ce.mEb.rGb.pr ) at = ce.mEb.rGb.pr.at;
				}
			}
			if( !testAt(at) && ce.Zb && !(typeof ce.Zb=="function") && ce.Zb.Fea && !(typeof ce.Zb.Fea=="function") && ce.Zb.Fea.Db && !(typeof ce.Zb.Fea.Db=="function") ) at = ce.Zb.Fea.Db.at;
			
			/*
			if( (!testAt(at)) ){
				for( p in ce ){
					if( typeof ce[p]=="string" && ce[p].length>28 ){
						at = ce[p];
					}
				}
			}
			*/
			if( (!testAt(at)) ){	// Complete failure. Try to relocate.
				var location = this._gtdinboxPage.settings.atLocation;
				if( location ){
					var splitter = location.split(".");
					var v = ce;
					for( var i = 0; i < splitter.length; i++ ){
						if( typeof v[splitter[i]] == "undefined" || typeof v[splitter[i]]=="function" || !v[splitter[i]] ){
							v = null;
							break;
						}
						v = v[splitter[i]];
					}
					if( v ) at = v;
				}
			}
			/*
			if( (!testAt(at)) ){
				var w = this._gtdinboxPage.unsafeWindow.top.js._GM_chatEngine;
				var v = null;
				for( p in w ){
					if( typeof w[p]=="string" && w[p].length>28 ){
						v = p;
						at = w[p];
						break;
					}
					try{
					for( p2 in w[p] ){
						if( typeof w[p][p2]=="string" && w[p][p2].length>28 ){
							v = p + "." + p2;
							at = w[p][p2];
							break;
						}
						try{
						for( p3 in w[p][p2] ){
							try{
							if( typeof w[p][p2][p3]=="string" && w[p][p2][p3].length>28 ){
								v = p + "." + p2 + "." + p3;
								at = w[p][p2][p3];
								break;
							}
							if( w[p][p2][p3]!=top && w[p][p2][p3]!=this._gtdinboxPage.unsafeWindow.top.js ){
								var i = 0;
								for( p4 in w[p][p2][p3] ){
									try{
									if( typeof w[p][p2][p3][p4]=="string" && w[p][p2][p3][p4].length>28 ){
										v = p + "." + p2 + "." + p3 + "." + p4;
										at = w[p][p2][p3][p4];
										break;
									}
									}catch(e){}
									if( i++ > 60 ) break;
								}
							}
							}catch(e){}
							if( v ) break;
						}
						}catch(e){}
						if( v ) break;
					}
					}catch(e){}
					if( v ) break;
				}
				if( v ) this._gtdinboxPage.settings.atLocation = v;
			}
			*/
			if( !testAt(at) ) at = "";
			return at;
		case "email-address":
			failStr = "noEmail";
			var fCheckEmail = function(e){
					if( typeof e=="string" && /\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i.test(e)  ) return true;
					return false;
				};
			var email = "";
			if( this._gtdinboxPage.unsafeWindow ){
				email = this._gtdinboxPage.unsafeWindow.top.js.USER_EMAIL;
				if( fCheckEmail(email) ) return email;
				email = this._gtdinboxPage.unsafeWindow.top.js.GLOBALS[10];
				if( fCheckEmail(email) ) return email;
				
				// try to retrieve
				var v = this._gtdinboxPage.gtdinboxBrowser.options.getOption("char", "gtdinbox.emailVariable", "");
				if( v )	email = this._gtdinboxPage.unsafeWindow.top.js[v];
				if( !fCheckEmail(email) ){
					var js = this._gtdinboxPage.unsafeWindow.top.js;
					for( v in js ){
						if( typeof js[v]=="string" && /\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i.test(js[v]) ){
							email = js[v];
							this._gtdinboxPage.gtdinboxBrowser.options.setOption("char", "gtdinbox.emailVariable", v);
							break;
						}
					}
				}
				if( fCheckEmail(email) ) return email;
			}
			// Try hooking into element. This will fail during loading for unknown reasons. 
			var elEmail = this.element("email-address");
			if( elEmail && elEmail.innerHTML && fCheckEmail(elEmail.innerHTML) ){
				return elEmail.innerHTML;
			}
			
			return failStr;
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("gmaildom local\n" + e.toString());
}
	
	return failStr;
	
	/* USE IN FIREBUG - replace the long string with whatever 'at' variable is sent when label added/renamed
	

try{
for( p in window ){
	if( typeof window[p]=="string" && window[p]=="xn3j2xynvbljnr9ayctmodxm4vx80c" ){
		console.log(p);
	}else{   
		try{
		if( typeof window[p]=="object" ){
			for( p2 in window[p] ){
				if( typeof window[p][p2]=="string" && window[p][p2]=="xn3j2xynvbljnr9ayctmodxm4vx80c" ){
					console.log(p + " - " + p2);    
				}else{
for( p3 in window[p][p2] ){
if( typeof window[p][p2][p3]=="string" && window[p][p2][p3]=="xn3j2xynvbljnr9ayctmodxm4vx80c" ){
console.log(p + " - " + p2 + " - " + p3);    
}
}
				}
			}
		}
		}catch(e){}
	}    
}
console.log("done");
}catch(e){
console.log(e);
}

=====

var w = top.js._GM_chatEngine;
var atS = "xn3j2xynvbljnr9ayctmodxm4vx80c";

for( p in w ){
    if( typeof w[p]=="string" && w[p]==atS ){
        console.log(p);
        break;
    }
    try{
    for( p2 in w[p] ){
        if( typeof w[p][p2]=="string" && w[p][p2].length>28 ){
            console.log(p + " - " + p2);
            break;
        }
        try{
        for( p3 in w[p][p2] ){
            try{
            if( typeof w[p][p2][p3]=="string" && w[p][p2][p3].length>28 ){
                console.log(p + " - " + p2 + " - " + p3);
                break;
            }
            if( w[p][p2][p3]!=top && w[p][p2][p3]!=top.js ){
                var i = 0;
                for( p4 in w[p][p2][p3] ){
                    try{
                    if( typeof w[p][p2][p3][p4]=="string" && w[p][p2][p3][p4].length>28 ){
                        console.log(p + " - " + p2 + " - " + p3 + " - " + p4);
                        break;
                    }
                    }catch(e){console.log(e)}
                    if( i++ > 100 ) break;
                }
            }
            }catch(e){console.log(e)}
        }
        }catch(e){console.log(e)}
    }
    }catch(e){console.log(e)}
}
console.log("done");
	
	*/
};