function RemoteErrorCheck(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
};


RemoteErrorCheck.prototype.checkServerMessages = function(){

try{
	// Check with gtdinbox.com/gtdinbox-servermessages.htm
	// Format: warning=2.10|gmailDOM=2.11-0
	
	var req = new XMLHttpRequest();
	req.open("GET", ("http://gtdinbox.com/gtdinbox_remote-error-check.htm?" + (new Date()).valueOf()), true);
	req.onreadystatechange = GIPROTOTYPE.bind(this, function(){
			if( req.readyState==4 ){
				if( req.status==200 ){
					try{
					
					// Securely load JSON:
					
					
					if( !req.responseText || req.responseText.indexOf("{")==-1 ) return;
										
					var sb = Components.utils.Sandbox("http://www.productivefirefox.com");
					try{
						Components.utils.evalInSandbox( req.responseText, sb );
					}catch(e){
						if( GTDDEBUGMODE ) alert("RemoteErrorCheck checkServerMessages onreadystatechange evalInSandbox\n" + e.toString() + "\n" + req.responseText);
						return;
					}
					
					var gtdInboxRemote = sb.gtdInboxRemote;
					
					if( typeof gtdInboxRemote == "undefined" ) return;
					if( typeof gtdInboxRemote != "object" ) return;
					if( typeof gtdInboxRemote.latestRelease != "undefined" ){
						if( typeof gtdInboxRemote.latestRelease != "object" ) return;
						if( typeof gtdInboxRemote.latestRelease.version != "undefined" && typeof gtdInboxRemote.latestRelease.version != "string" && typeof gtdInboxRemote.latestRelease.version != "number" ) return;
						if( typeof gtdInboxRemote.latestRelease.url != "undefined" && typeof gtdInboxRemote.latestRelease.url != "string" ) return;
						if( typeof gtdInboxRemote.latestRelease.displayVersion != "undefined" && typeof gtdInboxRemote.latestRelease.displayVersion != "string" ) return;
					}
					if( typeof gtdInboxRemote.latestBeta != "undefined" ){
						if( typeof gtdInboxRemote.latestBeta != "object" ) return;
						if( typeof gtdInboxRemote.latestBeta.version != "undefined" && typeof gtdInboxRemote.latestBeta.version != "string" ) return;
						if( typeof gtdInboxRemote.latestBeta.url != "undefined" && typeof gtdInboxRemote.latestBeta.url != "string" ) return;
						if( typeof gtdInboxRemote.latestBeta.displayVersion != "undefined" && typeof gtdInboxRemote.latestBeta.displayVersion != "string" ) return;
					}
					if( typeof gtdInboxRemote.issueWarning != "undefined" && typeof gtdInboxRemote.issueWarning != "string" ) return;
					if( typeof gtdInboxRemote.latestMiniPatch != "undefined" && typeof gtdInboxRemote.latestMiniPatch != "string" ) return;
					
					
					var foundGmailDOM = false;
					var version = this._gtdinboxPage.settings.lastVersion;
					if( gtdInboxRemote.latestRelease && parseFloat(gtdInboxRemote.latestRelease.version) > version ){	// New release
						this._gtdinboxPage.elUpdate_NewRelease.style.display = "";
						this._gtdinboxPage.elUpdate.style.display = "";
						var elA = this._gtdinboxPage.elUpdate_NewRelease.getElementsByTagName("A")[0];
						elA.href = gtdInboxRemote.latestRelease.url;
						elA.innerHTML = gtdInboxRemote.latestRelease.displayVersion || gtdInboxRemote.latestRelease.version;
												
						if( gtdInboxRemote.latestBeta && gtdInboxRemote.latestBeta.version > gtdInboxRemote.latestRelease.version  ){ // Even newer beta too
							this._gtdinboxPage.elUpdate_NewBeta.style.display = "";
							var elA = this._gtdinboxPage.elUpdate_NewBeta.getElementsByTagName("A")[0];
							elA.href = gtdInboxRemote.latestBeta.url;
							elA.innerHTML = gtdInboxRemote.latestBeta.displayVersion || gtdInboxRemote.latestBeta.version;
						}
					}else if( gtdInboxRemote.latestBeta && parseFloat(gtdInboxRemote.latestBeta.version) > version ){ // New beta
						this._gtdinboxPage.elUpdate_NewBeta.style.display = "";
						this._gtdinboxPage.elUpdate.style.display = "";
						var elA = this._gtdinboxPage.elUpdate_NewBeta.getElementsByTagName("A")[0];
						elA.href = gtdInboxRemote.latestBeta.url;
						elA.innerHTML = gtdInboxRemote.latestBeta.displayVersion || gtdInboxRemote.latestBeta.version;
					}else if( gtdInboxRemote.latestMiniPatch ){
						var versionData = gtdInboxRemote.latestMiniPatch.split("-");
						this._callbackGmailDOM( versionData[0], versionData[1] );
					}else if( gtdInboxRemote.issueWarning ){
						this._gtdinboxPage.elVersionWarning.style.display = "";
					}
								
									
					if( !foundGmailDOM ){	// Make sure we wipe any existence of 'gmailDOM' from the files
						if( !this._gtdinboxPage.settings.remoteErrorCheck ) this._gtdinboxPage.settings.remoteErrorCheck = {};
						this._gtdinboxPage.settings.remoteErrorCheck.currentGmailDomVersion = 0;
						this._gtdinboxPage.settings.remoteErrorCheck.currentGmailDomRevision = 0;
						this._gtdinboxPage.saveSettings();
						this._gtdinboxPage.db.execute("DELETE FROM autoupdated_js WHERE filename = 'gmailDOM'");
					}
					
					
					}catch(e){
						if( GTDDEBUGMODE ) alert("RemoteErrorCheck checkServerMessages onreadystatechange\n" + e.toString());
					}	
				}
			}
		});
	req.send(null);

}catch(e){
	if( GTDDEBUGMODE ) alert("RemoteErrorCheck checkServerMessages\n" + e.toString());
}	

};


RemoteErrorCheck.prototype._callbackGmailDOM = function(gmailDomVersion, revision){

try{
	// If gmailDomVersion older than GTDInbox current version; ignore it.
	// If no entry in the DB, download a new version
	// If revision more recent than the last downloaded, download a new version
	// 
	// To download a new version, get 2 copies from different servers. Only use if they're identical. Reasonable test against one site being hacked and replaced with malicious javascript.
	
	var version = this._gtdinboxPage.settings.lastVersion;
	var knownGmailDomVersion = this._gtdinboxPage.settings.remoteErrorCheck? this._gtdinboxPage.settings.remoteErrorCheck.currentGmailDomVersion : 0;
	var knownGmailDomRevision = this._gtdinboxPage.settings.remoteErrorCheck? this._gtdinboxPage.settings.remoteErrorCheck.currentGmailDomRevision : 0;
	

	
	if( version<=gmailDomVersion ){
		// Try to get file
		var update = false;
		//this._gtdinboxPage.db.execute("DELETE FROM autoupdated_js WHERE filename = 'gmailDOM'"); // debug
		var file = this._getFileFromDB("gmailDOM");
		if( file ){	// Check for newer versions
			if( (gmailDomVersion>knownGmailDomVersion) || (gmailDomVersion==knownGmailDomVersion && revision>knownGmailDomRevision ) ){	// needs update
				update = true;
			}
		}else{ // Force an update
			update = true;
		}
		if( update ){	// Download latest version from two sources
			// Update settings
			
			this._gtdinboxPage.elMiniPatch.style.display = "";
			this._gtdinboxPage.elMiniPatch.addEventListener("click", GIPROTOTYPE.bindAsEventListener( this, this._updateGmailDOM ), true );
			
		}
	}

}catch(e){
	if( GTDDEBUGMODE ) alert("RemoteErrorCheck _callbackGmailDOM\n" + e.toString());
}		

};
RemoteErrorCheck.prototype._updateGmailDOM = function(){
try{
	// To download a new version, get 2 copies from different servers. Only use if they're identical. Reasonable test against one site being hacked and replaced with malicious javascript.
	
	// Prep space for the downloads:
	this._gmailDomSources = [];
	// Process each download:
	var onDownloadSuccess = GIPROTOTYPE.bind(this, function(file){
			try{
			
			this._gmailDomSources.push(file);
			if( this._gmailDomSources.length==2 ){
				if( this._gmailDomSources[0]==this._gmailDomSources[1] ){	// Success!
					// Store to DB.
					// Suggest user restart.
					
					if( !this._gtdinboxPage.settings.remoteErrorCheck ) this._gtdinboxPage.settings.remoteErrorCheck = {};
					this._gtdinboxPage.settings.remoteErrorCheck.currentGmailDomVersion = gmailDomVersion;
					this._gtdinboxPage.settings.remoteErrorCheck.currentGmailDomRevision = revision;
					this._gtdinboxPage.saveSettings();
					
					this._gtdinboxPage.db.execute("DELETE FROM autoupdated_js WHERE filename = 'gmailDOM'");
					this._gtdinboxPage.db.executeWithParams("INSERT INTO autoupdated_js (filename, file) VALUES('gmailDOM', ?1)", [file]);
					alert( this._gtdinboxPage.stringBundle.getString("RemoteErrorCheck.JsUpdateSuccess") );
				}
			}
			
			}catch(e){
				if( GTDDEBUGMODE ) alert("RemoteErrorCheck _callbackGmailDOM onDownloadSuccess\n" + e.toString());
			}	
		});
	// Do the downloads:
	var req = new XMLHttpRequest();
	req.open("GET", "http://gtdinbox.com/GmailDOM.js", true);
	req.onreadystatechange = GIPROTOTYPE.bind(this, function(){
			if( req.readyState==4 ) if( req.status==200 ) onDownloadSuccess(req.responseText);
		});
	req.send(null);
	var req2 = new XMLHttpRequest();
	req2.open("GET", "http://gtdinbox.captbunzo.com/GmailDOM.js", true);
	req2.onreadystatechange = GIPROTOTYPE.bind(this, function(){
			if( req2.readyState==4 ) if( req2.status==200 ) onDownloadSuccess(req2.responseText);
		});
	req2.send(null);

}catch(e){
	if( GTDDEBUGMODE ) alert("RemoteErrorCheck _updateGmailDOM\n" + e.toString());
}		

};


RemoteErrorCheck.prototype._getFileFromDB = function(filename){

try{

	var result = {file:""};
	var fRow = GIPROTOTYPE.bind(this, function(statement){
			result.file = statement.getString(0) || "";
		});
	this._gtdinboxPage.db.select( "SELECT file FROM autoupdated_js WHERE filename = \"" + filename + "\"", fRow);
	
	return result.file;
	
}catch(e){
	if( GTDDEBUGMODE ) alert("RemoteErrorCheck getFileFromDb\n" + e.toString());
}	
};