/* Copyright Andy Mitchell 2007. No warranties */

function ThreadActionsUI(gtdinboxPage, elParent, noCreate){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = this._gtdinboxPage._labels;
	
	this._eventObservers = new GtdEventObservers(this);
	this._eventHandlers = new GtdEventHandlers_Mutator(this);
	
	if( !noCreate ) this._create(elParent);
};

ThreadActionsUI.prototype._create = function(elParent){
	this.el = this._doc.createElement("DIV");
		this.el.className = "thread-actions";
	if( elParent ) elParent.appendChild( this.el );
	
	/*
	var elMarkRead = this._doc.createElement("BUTTON");
		elMarkRead.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.MarkAsRead");	
		this._eventObservers.observe(elMarkRead, "click", this._clickMarkRead, false);
	this.el.appendChild(elMarkRead);
	*/
	
	var elReportSpam = this._doc.createElement("BUTTON");
		elReportSpam.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.ReportSpam");	
		this._eventObservers.observe(elReportSpam, "click", this._reportSpam, false);
	this.el.appendChild(elReportSpam);
	
	var elDelete = this._doc.createElement("BUTTON");
		elDelete.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.Delete");	
		this._eventObservers.observe(elDelete, "click", this._clickDelete, false);
	this.el.appendChild(elDelete);
	
	var elArchive = this._doc.createElement("BUTTON");
		elArchive.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.Archive");	
		this._eventObservers.observe(elArchive, "click", GIPROTOTYPE.bind(this, function(){this._doMarkReadAndArchive(null, true)}), false);
	this.el.appendChild(elArchive);
	
	this.el.appendChild( this.getFinishedButton() );
		

};

ThreadActionsUI.prototype.refresh = function(thread){
	this.thread = thread;
};

ThreadActionsUI.prototype.getFinishedButton = function(){
	var elFinish = this._doc.createElement("BUTTON");
		elFinish.innerHTML = this._gtdinboxPage.stringBundle.getString("ThreadActions.Finished");	
		elFinish.title = this._gtdinboxPage.stringBundle.getString("ThreadActions.Finished.tooltip");	
		elFinish.style.fontWeight = "bold";
		this._eventObservers.observe(elFinish, "click", this._clickFinish, false);
	return elFinish;
};


ThreadActionsUI.prototype._removeStar = function(event, callback){
try{
	var f = GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute && el.getAttribute("act")=="4" ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
			if( callback ){
				setTimeout( GIPROTOTYPE.bind(this, function(){	
						callback();	// TODO improve by monitoring alert-box to see when mark-read is done
					}), 850);
			}
			return true;
		}
	});
	var found = this._labels._doMoreAction(f);
	if( !found && callback ) callback();
}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui clickMarkRead\n" + e.toString());
}
};

ThreadActionsUI.prototype._clickMarkRead = function(event, noClickFinishEvent, callback){
try{
	
	var f = GIPROTOTYPE.bind(this, function(el){
		if( el.getAttribute && el.getAttribute("act")=="1" ){
			GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
			if( callback || !noClickFinishEvent ){
				setTimeout( GIPROTOTYPE.bind(this, function(){	
						if( !noClickFinishEvent ) this._eventHandlers.broadcast("click-finished");
						if( callback ) callback();	// TODO improve by monitoring alert-box to see when mark-read is done
					}), 850);
			}
			return true;
		}
	});
	var found = this._labels._doMoreAction(f);
	if( !found && callback ) callback();
}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui clickMarkRead\n" + e.toString());
}
};
ThreadActionsUI.prototype._reportSpam = function(event){
	var el = this._gtdinboxPage.gmailDOM.element("spam-button");
	if( el ){
		GIPROTOTYPE.doMouseEvent(this._doc, el, "click");
		this._eventHandlers.broadcast("click-finished");
	}
};
ThreadActionsUI.prototype._clickArchive = function(event, callback){
try{
	var el = this._gtdinboxPage.gmailDOM.element("archive-button");
	if( el ){	// Found button
		GIPROTOTYPE.doMouseEvent(this._doc, el, "click");
		this._eventHandlers.broadcast("click-finished");
		if( callback ){
			setTimeout( GIPROTOTYPE.bind(this, function(){
					callback();
				}), 850 );
		}
	}else{	// See if in drop down menu
		var f = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute && el.getAttribute("act")=="7" ){
				GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
				if( callback ){
					setTimeout( GIPROTOTYPE.bind(this, function(){	
							this._eventHandlers.broadcast("click-finished");
							if( callback ) callback();
						}), 850);
				}
				return true;
			}
		});
		var found = this._labels._doMoreAction(f);
		if( !found && callback ) callback();
	}

}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui clickArchive\n" + e.toString());
}
};
ThreadActionsUI.prototype._clickDelete = function(event){
try{
	var el = this._gtdinboxPage.gmailDOM.element("delete-button");
	if( el ){
		GIPROTOTYPE.doMouseEvent(this._doc, el, "click");
		this._eventHandlers.broadcast("click-finished");
	}else{	// no delete button, could be Sent Mail?
		var f = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute && el.getAttribute("act")=="10" ){
				GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
				setTimeout( GIPROTOTYPE.bind(this, function(){
						//this._eventHandlers.broadcast("click-finished");
					}), 500);
				return true;
			}
		});
		this._labels._doMoreAction(f);
	}	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadactionsui clickDelete\n" + e.toString());
}
};
ThreadActionsUI.prototype._clickFinish = function(event){
try{
	if( !this.thread ){
		alert( this._gtdinboxPage.stringBundle.getString("ThreadActions.Finished.NoThreadError") );
		return;
	}

	var lightbox = null;
	if( this._gtdinboxPage.view("view")=="tl" ){
		lightbox = new GtdLightbox(this._gtdinboxPage, this._gtdinboxPage.doc.body);
		
		var subject = this.thread.subject? (" '" + this.thread.subject + "'") : "";
		lightbox.setType( "processing", {msg:(this._gtdinboxPage.stringBundle.getString("ThreadActions.Finishing") + subject)} );
		lightbox.active(true);
	}

	// Remove all statuses; mark as read; archive
	var settingsStatuses = this._gtdinboxPage.settings.labels.types["Statuses"];
	var statusPrefix = settingsStatuses.prefix;
	var statusFinished = settingsStatuses.prefix + settingsStatuses.defaults.Finished;
	var labels = GIPROTOTYPE.clone(this.thread.labels);
	var hasStatusFinished = false;
	for( var i = 0; i < labels.length; i++ ){	// remove any instance of finished; incase processing after drop down label click has applied a label
		if( labels[i]==statusFinished ){
			hasStatusFinished = true;
			labels.splice(i,1)
			break;
		}
	}
	
	for( var i = 0; i < labels.length; i++ ){
		this._gtdinboxPage.gmailDOM.removeLabelFromThread(this.thread.id, labels[i]);
	}
	
	if( !hasStatusFinished && this._labels.hasLabel(statusFinished) ){	// has S/Finished, so add it
		this._gtdinboxPage.gmailDOM.addLabelToThread(this.thread.id, statusFinished);
	}
	
	var finalCallback = GIPROTOTYPE.bind(this, function(){
			if( lightbox ) lightbox.active(false);
		});
	this._doMarkReadAndArchive(finalCallback);
	
	
	/* PRE DIRECT-CODE METHOD
	
	var labelled = {'count':0};
	var fCallback = GIPROTOTYPE.bind(this, function(act){
		if( --labelled.count==0 ){	// move on
			this._doMarkReadAndArchive(finalCallback);
		}
	});
	if( this._labels.hasLabel(statusFinished) ){	// has S/Finished, so add it
		labelled.count++;
		this._labels.labelThread({labelname:statusFinished, 'on':true, 'threads':this.thread, 'fCallback':fCallback});
	}
	// Remove existing labels:
	for( var i = 0; i < labels.length; i++ ){
		if( labels[i].indexOf(statusPrefix)==0 ){
			labelled.count++;
			this._labels.labelThread({labelname:labels[i], 'on':false, 'threads':this.thread, 'fCallback':fCallback});
		}
	}
	*/
	
}catch(e){
	if( typeof lightbox!="undefined" && lightbox ) lightbox.active(false);
	if( GTDDEBUGMODE ) alert("threadactionsui clickFinish\n" + e.toString());
}
};
ThreadActionsUI.prototype._doMarkReadAndArchive = function(callback, preserveStar){
	
	var markReadAndArchive = GIPROTOTYPE.bind(this, function(){
		this._clickMarkRead(null, true, GIPROTOTYPE.bind(this, function(){	// mark it as read
				this._clickArchive(null, callback);	//click archive
			}));
	});
	if( !preserveStar && this._gtdinboxPage.settings.labels.starForNextAction ){
		this._removeStar(null, markReadAndArchive);
	}else{
		markReadAndArchive();
	}
};




ThreadActionsUI.prototype.destroy = function(){
	this._eventHandlers.destroy();
	this._eventObservers.destroy();
};